<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:didl="urn:mpeg:mpeg21:2002:01-DIDL-NS" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
    <html>
      <head>
         <title>
            <xsl:value-of select="//didl:DESCRIPTOR[@ID='LECTURE_TITLE']/didl:STATEMENT"></xsl:value-of>
         </title>
         <script type="text/javascript">
 	         var file_names = new Array(
              <xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>"
                  </xsl:when>
                  <xsl:otherwise>
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>",               </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
              )
           var durations = new Array(
             <xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    <xsl:value-of select="@FRAGMENT * 1000"></xsl:value-of>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="@FRAGMENT * 1000"></xsl:value-of>,
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
              )
           <xsl:text disable-output-escaping="yes">
           var t; // variable for setTimeout
			     var j = 0; // counter for the slide show (array index)
         	 var len = file_names.length;
			     var paused = 0; // whether paused or not
           var after_pause = 0; // whether the next slide in the show is right after pause
           var temp_delay; // stores the time left in a slide
			     var delay; // time between calling runSlideShow in milliseconds
			     var t_slide_start; //time in milliseconds a particular slide showed up on screen
			     var t_click_pause; //time in milliseconds the user presses Play/Pause
			     var paused_on = -2; // records which slide is displaying when pause is clicked
			     var time; //variable for creating new date instances

			     // stores the number of the next slide to be shown starting from 1
			     var current = 1;
			     var sync = 1; // whether video and slides are in sync
				function popUp(URL) {
				  day = new Date();
		      	          id = day.getTime();
				  eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=500,height=800,left = 490,top = 362');");
	        	        }
			     /* Runs the slide-show whether at the time of loading or after a pause
	 		      * Pre: j is the index of the slide to be shown in the array
	 		      * Post: j is incremented for the next function call
	 		      */
			      function runSlideShow ()
			      {
				     // assertion: first time this function is run after pause
				     if (after_pause == 1)
				     {
					    // this function call should display the same slide before the pause
					    j--;
					    delay = temp_delay; // temp_delay is calculated in pauseResume()
					    after_pause = 0;
				     }
				     else
				     {
					   delay = durations[j];
				     }
	
				     // assertion: video and slides are out of sync, but the slide that the user
				     // is on is the same as the slide in the slide-show
				     if (current == j)
				     {
					    // moves the still image behind and we are back in sync
		          moveToBack();
					    sync = 1;
				     }
	
				     // assertion: j is within the valid indices for the file_names array
				     if (j &lt;= len - 1)
				     {
					    // change the source of the slide
					    document.getElementById('slide').src = file_names[j];
					    // get the time that this slide started
					    time = new Date();
					    t_slide_start = time.getTime();
					    // increment j for the next runSlideShow() function call
					    j++;
					    // call runSlideShow() after the number of milliseconds stored in delay
					    t = setTimeout("runSlideShow()", delay);
             }
             // assertion: the slide-show is over
		         else if (j &gt; len - 1)
		         {
			        // disable Play/Pause button and stop movie
			        noPause();
			        document.getElementById('movie').stop();
			        document.getElementById('sound').stop();
             }
            }
	          /* Cancels the timer t */
           	function clearTimer()
            {
		         clearTimeout(t);
	          }
            function pauseResume()
	          {
		         // assertion: movie and slide-show are not paused
             if (paused == 0)
		         {
			        // pause the movie, cancel the timer and get the time that the user
			        // pressed Play/Pause
			        document.getElementById('movie').pause();
			        document.getElementById('sound').pause();
			        clearTimer();
			        time = new Date();
			        t_click_pause = time.getTime();
        			// assertion: the slide that the user paused on is different from this
			        // slide
			        if (paused_on != (j-1))
			        {
				       paused_on = j - 1;
				       // the next time runSlideShow is called, the delay for calling it
				       // a second time should be the amount of time left in the silde
				       // that's been paused
				       temp_delay = durations[paused_on] - (t_click_pause - t_slide_start);
			        }
			        // assertion: user has paused on this slide before
			        else
			        {
				       // the delay should be decreased from temp_delay, not the total
				       // duration of the slide
				       temp_delay = temp_delay - (t_click_pause - t_slide_start);
              }
      			  // change states of variables
			        after_pause = 1;
			        paused = 1;
		         }
		         // assertion: movie and slide-show are already paused
		         else
		         {
			        // change state the variables and unpause both
			        paused = 0;
			        moveToBack();
			        document.getElementById('movie').play();
			        document.getElementById('sound').play();
			        <xsl:if test="//didl:DESCRIPTOR[@ID='HAS_TIMESTAMP']/didl:STATEMENT != 0">
			          runSlideShow();
			        </xsl:if>
		         }
	          }

            /* Moves the stilll image in front of the slide-show */
	          function moveToFront()
	          {
		         document.getElementById('image').style.zIndex = "1";
	          }
	
	          /* Moves the still image behind the slide-show */
	          function moveToBack()
	          {
		         document.getElementById('image').style.zIndex = "-1";
	          }
            /* Changes the source of the still image according to the current slide to be
	           * shown
	           */
	           function changeImage()
	           {
		          document.getElementById('image').src = file_names[current-1];
	           }

	           /* Shows the first slide */
	           function showFirst()
	           {
		          // change "current" to 1 and "sync" to 0 (ie. not in sync)
		          current=1;
		          changeImage();
		          moveToFront();
		          sync=0;
	           }
	
 	           /* Show the last slide */
	           function showLast()
	           {
		          current=len;
		          changeImage();
		          moveToFront();
		          sync=0;
	           }

             /* Show the next slide */
	           function showNext()
	           {
		          // assertion: media are in sync
		          if (sync == 1)
		          {
			         // calculate the number of the next slide
			         current = j + 1;
			         // assertion: the number is valid (ie. not greater than the number of
			         // total slides
			         if (current &lt;= len)
			         {
				        // change the still image to the appropriate one and move it in
	              // front of the slide-show
				        changeImage();
				        sync = 0;
				        moveToFront();
               }
              }
		          // assertion: media are out of sync
		          else
              {
			         // assertion: there are more slides available for display
			         if (current &lt; len )
			         {
				        // increment "current" and show the still image
				        current ++;
				        changeImage();
				        moveToFront();
		           }
              }
	           }

	           /* Shows the previous slide */
	           function showPrev()
	           {
		          // assertion: media are in sync
		          if (sync == 1)
		          {
			         // calculate the number of the previous slide
			         current = j - 1;
			         // assertion: the number is valid (ie. not less than 1)
			         if (current &gt;= 1)
			         {
				        // change the still image to the appropriate one and move it in
				        // front of the slide-show
				        changeImage();
				        sync = 0;
				        moveToFront();
			         }
		          }
		          // assertion: media are out of sync
		          else
		          {
			         // assertion: there are slides before this one
			         if (current &gt; 1)
			         {
				        // decrease "current" and show the still image
				        current--;
				        changeImage();
				        moveToFront();
			         }
		          }
	           }

	           /* Shows the slide indicated by num
	           * Note: num starts from 1 (ie. 1 for the first slides, etc.)
	           */
	           function showSlide(num)
	           {
		          current=num;
              changeImage();
		          sync = 0;
		          moveToFront();
	           }

	           /* Disables the Play/Pause button */
	           function noPause()
	           {
		          document.getElementById('pauseBtn').disabled = true;
	           }
          </xsl:text>
         </script>
      </head>
      <body >
        <xsl:if test="//didl:DESCRIPTOR[@ID='HAS_TIMESTAMP']/didl:STATEMENT != 0">
          <xsl:attribute name="onload">runSlideShow()</xsl:attribute>
          <xsl:attribute name="onunload">clearTime()</xsl:attribute>
        </xsl:if>
        <table border="0" height="100%" width="100%">
          <tr>
            <td align="center" bgcolor="lightgrey" rowspan="5" valign="top" width="1%">
              <!-- Logo -->
              <img src="http://wwwtest.dsp.utoronto.ca/myfiles/logo.jpg" />
              <!-- Movie object -->
              <object classid="clsid:22D6F312-B0F6-11D0-94AB-0080C74C7E95" height="96" id="movie" width="128">
                <param name="FileName">
                  <xsl:attribute name="value">
                     <!--<xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='VIDEO']/didl:RESOURCE/@REF"></xsl:value-of>-->
                     <xsl:value-of select="//didl:DESCRIPTOR[@ID='PLAYLIST']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                  </xsl:attribute>
                </param>
                <param name="ShowControls" value="0"></param>
              </object>
              <object classid="clsid:22D6F312-B0F6-11D0-94AB-0080C74C7E95" height="0" id="sound" width="0">
                <param name="FileName">
                  <xsl:attribute name="value">
                    <xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='AUDIO']/didl:RESOURCE/@REF"></xsl:value-of>
                  </xsl:attribute>
                </param>
              </object>
              <form action="view.jsp" id="form1" method="post">
                <input id="pauseBtn" onclick="pauseResume()" type="button" value="Play/Pause"></input>
                <input name="submit" type="submit" value="Restart"></input>
              </form>
              <!-- Radio buttons -->
              <div style="overflow-y:scroll; width:120px; height:200px">
                <xsl:for-each select="//didl:ANCHOR">
                  <input name="slide_radio" onFocus="showSlide(1)" type="radio" value="1">
                    <xsl:attribute name="onFocus">
                      showSlide(<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:value-of>)
                    </xsl:attribute>
                         Chapter <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:value-of>
                  </input><br></br>
                </xsl:for-each>
              </div>
            </td>
            <td align="center" rowspan="4">
              <table border="1" width="420">
                <tr align="left">
                  <td>
                    <!-- Still image -->
                    <img id="image" style="position:absolute; z-index:-1;" width="420">
                    <xsl:attribute name="src">
                          <xsl:for-each select="//didl:ANCHOR">
                            <xsl:if test="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT = 1">
                              <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                            </xsl:if>
                          </xsl:for-each>
                    </xsl:attribute>

                    </img>
                    <!-- Slide-show -->
                    <img id="slide" src="1.bmp" width="420">
                      <xsl:attribute name="src">
                          <xsl:for-each select="//didl:ANCHOR">
                            <xsl:if test="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT = 1">
                              <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                            </xsl:if>
                          </xsl:for-each>
                      </xsl:attribute>
                    </img>
                  </td>
                </tr>
              </table>
            </td>
            <td align="center"><input onclick="showFirst()" type="button" value="First"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showPrev()" type="button" value="Prev"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showNext()" type="button" value="Next"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showLast()" type="button" value="Last"></input></td>
          </tr>
          <!-- Text chat links to another file -->
          <tr>
            <td colspan="2"><iframe src="textchat.html" width="100%"></iframe></td>
          </tr>
        </table>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
