<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:didl="urn:mpeg:mpeg21:2002:01-DIDL-NS" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
    <html>
      <head>
	      <title>Slides</title>
	      <script type="text/javascript">
          <xsl:text disable-output-escaping="yes">
	    self.focus();
            var slide_images = new Array();
            var durations = new Array();
            function slideshowImages()
	          {
		         var i = 0;
		         for (i=0; i&lt;slideshowImages.arguments.length; i++)
		         {
			        slide_images[i] = new Image();
			        slide_images[i].src = slideshowImages.arguments[i];
		         }
            }
            function slideshowDurations()
	          {
		         var i = 0;
		         for (i=0; i&lt;slideshowDurations.arguments.length; i++)
		         {
              durations[i] = slideshowDurations.arguments[i];
             }
           }
          </xsl:text>
          slideshowImages(<xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>"
                  </xsl:when>
                  <xsl:otherwise>
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>",               </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>);
          slideshowDurations (<xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    <xsl:value-of select="@FRAGMENT*1000"></xsl:value-of>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="@FRAGMENT*1000"></xsl:value-of>,
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>);
          <xsl:text disable-output-escaping="yes">
            var t; // variable for setTimeout
	          var j = 0; // counter for the slide show (array index)
           	var len = slide_images.length;
	          var paused = 0; // whether paused or not
	          var after_pause = 0; // whether the next slide in the show is right after pause
           	var temp_delay; // stores the time left in a slide
            var delay; // time between calling runSlideShow in milliseconds
	          var t_slide_start; //time in milliseconds a particular slide showed up on screen
	          var t_click_pause; //time in milliseconds the user presses Play/Pause
            var paused_on = -2; // records which slide is displaying when pause is clicked
	          var time; //variable for creating new date instances
            // stores the number of the next slide to be shown starting from 1
	          var current = 1;
	          var sync = 1; // whether video and slides are in sync
            /* Runs the slide-show whether at the time of loading or after a pause
	           * Pre: j is the index of the slide to be shown in the array
	           * Post: j is incremented for the next function call
             */
	          function runSlideShow()
	          {
		         // assertion: first time this function is run after pause
		         if (after_pause == 1)
		         {
	            // this function call should display the same slide before the pause
			        j--;
			        delay = temp_delay; // temp_delay is calculated in pauseResume()
			        after_pause = 0;
		         }
		         else
           	 {
			        delay = durations[j];
		         }
		         // assertion: video and slides are out of sync, but the slide that the user
		         // is on is the same as the slide in the slide-show
		         if (current == j)
		         {
			        // moves the still image behind and we are back in sync
			        //moveToBack();
			        sync = 1;
		         }
             // assertion: j is within the valid indices for the file_names array
		         if (j &lt;= len - 1)
		         {
			        // change the source of the slide
			        if (sync == 1)
			        {
				       document.images.slide.src = slide_images[j].src;
			        }
			        // get the time that this slide started
			        time = new Date();
			        t_slide_start = time.getTime();
             	// increment j for the next runSlideShow() function call
			        j++;
			        // call runSlideShow() after the number of milliseconds stored in delay
			        t = setTimeout("runSlideShow()", delay);
		         }
		         // assertion: the slide-show is over
		         else if (j &gt; len - 1)
		         {
			        // disable Play/Pause button and stop movie
			        noPause();
			        clearTimer();
			        //document.getElementById('sound').stop();
		         }
            }
            /* Cancels the timer t */
	          function clearTimer()
	          {
		         clearTimeout(t);
	          }
            function pauseResume()
	          {
		         // assertion: movie and slide-show are not paused
             if (paused == 0)
		         {
			        // pause the movie, cancel the timer and get the time that the user
			        // pressed Play/Pause
			        //document.getElementById('sound').pause();
			        clearTimer();
			        time = new Date();
			        t_click_pause = time.getTime();
             	// assertion: the slide that the user paused on is different from this
			        // slide
			        if (paused_on != (j-1))
			        {
				       paused_on = j - 1;
				       // the next time runSlideShow is called, the delay for calling it
				       // a second time should be the amount of time left in the silde
				       // that's been paused
				       temp_delay = durations[paused_on] - (t_click_pause - t_slide_start);
			        }
			        // assertion: user has paused on this slide before
			        else
			        {
				       // the delay should be decreased from temp_delay, not the total
				       // duration of the slide
				       temp_delay = temp_delay - (t_click_pause - t_slide_start);
			        }
              // change states of variables
			        after_pause = 1;
			        paused = 1;
             }
		         // assertion: movie and slide-show are already paused
		         else
		         {
			        // change state the variables and unpause both
			        paused = 0;
			        sync = 1;
			        //moveToBack();
			        //document.getElementById('sound').play();
			        runSlideShow();
		         }
	          }
            /* Changes the source of the still image according to the current slide to be
	           * shown
            */
	          function changeImage()
	          {
		         document.images.slide.src = slide_images[current-1].src;;
	          }
            /* Shows the first slide */
	          function showFirst()
	          {
		         // change "current" to 1 and "sync" to 0 (ie. not in sync)
		         current=1;
		         changeImage();
		         //moveToFront();
		         sync=0;
	          }
            /* Show the last slide */
	          function showLast()
	          {
		         current=len;
		         changeImage();
		         //moveToFront();
		         sync=0;
	          }
            /* Show the next slide */
	          function showNext()
	          {
		         // assertion: media are in sync
		         if (sync == 1)
		         {
			        // calculate the number of the next slide
			        current = j + 1;
			        // assertion: the number is valid (ie. not greater than the number of
			        // total slides
			        if (current &lt;= len)
			        {
				       // change the still image to the appropriate one and move it in
				       // front of the slide-show
				       changeImage();
				       sync = 0;
				       //moveToFront();
			        }
		         }
		         // assertion: media are out of sync
		         else
		         {
			        // assertion: there are more slides available for display
			        if (current &lt; len )
			        {
				       // increment "current" and show the still image
				       current ++;
				       changeImage();
				       //moveToFront();
			        }
		         }
	          }
            /* Shows the previous slide */
	          function showPrev()
	          {
		         // assertion: media are in sync
		         if (sync == 1)
		         {
			        // calculate the number of the previous slide
			        current = j - 1;
			        // assertion: the number is valid (ie. not less than 1)
			        if (current &gt;= 1)
			        {
				       // change the still image to the appropriate one and move it in
				       // front of the slide-show
				       changeImage();
				       sync = 0;
				       //moveToFront();
			        }
		         }
		         // assertion: media are out of sync
		         else
		         {
			        // assertion: there are slides before this one
			        if (current &gt; 1)
			        {
				       // decrease "current" and show the still image
				       current--;
				       changeImage();
				       //moveToFront();
			        }
             }
            }
            /* Shows the slide indicated by num
	          * Note: num starts from 1 (ie. 1 for the first slides, etc.)
	          */
	          function showSlide(num)
	          {
		         current=num;
		         changeImage();
		         sync = 0;
		         //moveToFront();
	          }

	          /* Disables the Play/Pause button */
	          function noPause()
	          {
		         //document.getElementById('pauseBtn').onclick = "";
		         //document.getElementById('pauseBtn').style.color = "red";
		         pauseBtn.href = "javascript:nothing()";
	          }
            function restart()
	          {
		         clearTimer();
		         j = 0;
		         paused = 0;
		         after_pause = 0;
		         paused_on = -2;
		         current = 1;
		         sync = 1;
		         pauseBtn.href = "javascript:pauseResume()";
		         runSlideShow();
	          }
           	function nothing()
	          {
	          }
          </xsl:text>
	      </script>
      </head>
      <body>
        <form action="view.jsp" method="post" name="the_form">
        <table border="0">
          <tr>
            <td align="center" colspan="4">
              <img id="slide" width="160">
                <xsl:attribute name="src">
                  <xsl:for-each select="//didl:ANCHOR">
                            <xsl:if test="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT = 1">
                              <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                            </xsl:if>
                  </xsl:for-each>
                </xsl:attribute>
              </img>
              <script type="text/javascript">
                runSlideShow();
              </script>
            </td>
          </tr>
          <tr>
            <td>
						  <!-- Prev button -->
						  <a href="javascript:showPrev()" style="color:blue; text-decoration:none"><font size="2">Prev</font></a>
					  </td>
            <td align="center" colspan="2">
              <select onchange="showSlide(selectedIndex+1)">
                <xsl:for-each select="//didl:ANCHOR">
                  <option>
                    Chapter <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:value-of>
                  </option>
                </xsl:for-each>
						  </select>
            </td>
            <td>
              <!-- Next button -->
						  <a href="javascript:showNext()" style="color:blue; text-decoration:none"><font size="2">Next</font></a>
            </td>
          </tr>
          <tr>
            <td>
                <!-- Sound object goes here -->
            </td>
            <td>
              <!-- Play/Pause Button -->
						  <a href="javascript:pauseResume()" id="pauseBtn" style="color:blue"><font size="2">Play/Pause</font></a>
            </td>
            <td>
              <a href="javascript:restart()" style="color:blue"><font size="2">Restart</font></a>
            </td>
          </tr>
          <tr>
            <td align="center" colspan="4">
              <a href="#" onClick="javascript:document.forms['the_form'].submit();" style="color:blue"><font size="2">Change Media</font></a>
            </td>
          </tr>
        </table>
        </form>
      </body>
    </html>

  </xsl:template>
</xsl:stylesheet>
